/*

  FSGetFreeDiskSpace()

  returns the number of free bytes on a disk drive

*/

#include <windows.h>

DWORD WINAPI FSGetFreeDiskSpace( LPCTSTR lpRootPathName )
{
	DWORD SectorsPerCluster, BytesPerSector, NumberOfFreeClusters, TotalNumberOfClusters;
	DWORD BytesFree;
	BOOL ok;

	ok = GetDiskFreeSpace( lpRootPathName, 
		                  &SectorsPerCluster, 
						  &BytesPerSector, 
						  &NumberOfFreeClusters, 
						  &TotalNumberOfClusters );

	if( ok )
		BytesFree = NumberOfFreeClusters * SectorsPerCluster * BytesPerSector;
	else
		BytesFree = 0;

	return BytesFree;
}
